package client_ORWS;

import java.awt.Color;
import java.awt.Frame;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JTextPane;
import javax.swing.Painter;
import javax.swing.SwingWorker;
import javax.swing.text.AttributeSet;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;
import javax.xml.ws.Holder;
import javax.xml.ws.WebServiceException;
import javax.xml.ws.WebServiceRef;
import javax.xml.ws.WebServiceRefs;
import jstl_ws_package.Probleme;
import jstl_ws_package.Solution;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

@WebServiceRefs({
   @WebServiceRef(name="service/WS1",
   type=jstl_ws_package.WebServiceJSTL_Service.class,
   wsdlLocation="http://orws.isima.fr:80/WebService_JSTL/WebService_JSTL?wsdl"),
   @WebServiceRef(name="service/WS2",
   type=jstl_ws_package.WebServiceJSTL_Service.class,
   wsdlLocation="http://orws2.isima.fr:80/WebService_JSTL/WebService_JSTL?wsdl") })


/**
 *
 * @author damienl
 */
public class Window extends javax.swing.JFrame {

    /**
     * Creates new form Window
     */
    public Window() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFrame1 = new javax.swing.JFrame();
        start = new javax.swing.JButton();
        path = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        displayGantt = new javax.swing.JCheckBox();
        randBierwirth = new javax.swing.JCheckBox();
        isGRASP = new javax.swing.JCheckBox();
        jScrollPane2 = new javax.swing.JScrollPane();
        Logger = new javax.swing.JTextPane();
        jLabel4 = new javax.swing.JLabel();
        isSinglEval = new javax.swing.JCheckBox();
        jLabel5 = new javax.swing.JLabel();
        jSeparator3 = new javax.swing.JSeparator();
        jSeparator5 = new javax.swing.JSeparator();
        canBierwirth = new javax.swing.JCheckBox();
        jSeparator7 = new javax.swing.JSeparator();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 2), new java.awt.Dimension(0, 2), new java.awt.Dimension(32767, 2));
        stopGrasp = new javax.swing.JButton();
        progressbar = new javax.swing.JProgressBar();
        nbRestart = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        nbVoisin = new javax.swing.JTextField();
        nbDeplacement = new javax.swing.JTextField();

        javax.swing.GroupLayout jFrame1Layout = new javax.swing.GroupLayout(jFrame1.getContentPane());
        jFrame1.getContentPane().setLayout(jFrame1Layout);
        jFrame1Layout.setHorizontalGroup(
            jFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        jFrame1Layout.setVerticalGroup(
            jFrame1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        start.setText("Start !");
        start.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startActionPerformed(evt);
            }
        });

        path.setText("src/Data_JSTL/la01_0_1");
        String tempPath = getClass().getProtectionDomain().getCodeSource().getLocation().toString();
        path.setText(tempPath.substring(tempPath.indexOf("/"), tempPath.lastIndexOf("/")+1));

        jLabel2.setText("Path of the instance to solve :");

        displayGantt.setSelected(true);
        displayGantt.setText("Display a Gantt diagram ?");
        displayGantt.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        displayGantt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                displayGanttActionPerformed(evt);
            }
        });

        randBierwirth.setSelected(true);
        randBierwirth.setText("A Random Vector :");
        randBierwirth.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        randBierwirth.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                randBierwirthActionPerformed(evt);
            }
        });

        isGRASP.setText("GRASP :");
        isGRASP.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        isGRASP.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                isGRASPActionPerformed(evt);
            }
        });

        jScrollPane2.setViewportView(Logger);

        jLabel4.setText("Evaluation Type :");

        isSinglEval.setSelected(true);
        isSinglEval.setText("Single evaluation :");
        isSinglEval.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        isSinglEval.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                isSinglEvalActionPerformed(evt);
            }
        });

        jLabel5.setText("Display Options :");

        canBierwirth.setText("A Cannonical Vector :");
        canBierwirth.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        canBierwirth.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                canBierwirthActionPerformed(evt);
            }
        });

        stopGrasp.setText("Stop Grasp !");

        nbRestart.setText("00");
        nbRestart.setEnabled(false);
        nbRestart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nbRestartActionPerformed(evt);
            }
        });

        jLabel1.setText("nb restart :");

        jLabel3.setText("nb deplacement :");

        jLabel6.setText("nb voisin :");

        nbVoisin.setText("00");
        nbVoisin.setEnabled(false);
        nbVoisin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nbVoisinActionPerformed(evt);
            }
        });

        nbDeplacement.setText("00");
        nbDeplacement.setEnabled(false);
        nbDeplacement.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nbDeplacementActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator3)
                    .addComponent(jSeparator7)
                    .addComponent(jScrollPane2)
                    .addComponent(jSeparator5)
                    .addComponent(path)
                    .addComponent(progressbar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 199, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(isSinglEval)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(canBierwirth))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(6, 6, 6)
                                .addComponent(isGRASP)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(nbRestart, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(nbDeplacement, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(randBierwirth)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel6)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(nbVoisin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(filler1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(start, javax.swing.GroupLayout.PREFERRED_SIZE, 141, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(229, 229, 229)
                        .addComponent(stopGrasp, javax.swing.GroupLayout.PREFERRED_SIZE, 134, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(displayGantt)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 199, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(progressbar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(11, 11, 11)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(path, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(isGRASP, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(nbRestart, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1)
                            .addComponent(jLabel3)
                            .addComponent(jLabel6)
                            .addComponent(nbVoisin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(nbDeplacement, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(canBierwirth)
                            .addComponent(isSinglEval)
                            .addComponent(randBierwirth))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(filler1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(displayGantt, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(stopGrasp, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(start, javax.swing.GroupLayout.DEFAULT_SIZE, 57, Short.MAX_VALUE))
                .addGap(24, 24, 24))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

   private void displayGantt(jstl_ws_package.WebServiceJSTL port, Probleme un_prob, Solution une_sol) {
       
       if (une_sol !=null) {
                        
            BufferedImage image = null;
            byte[] ganttDiagram =null;
            int iter = path.getText().lastIndexOf("/");
            int length = path.getText().length();
            String problemName = path.getText().substring(iter+1, length);

            if(displayGantt.isSelected()) {
                appendToPane(Logger, "Getting Gantt Diagram. \n", Color.blue);
                ganttDiagram = port.getGantt(un_prob, une_sol, problemName);

                ByteArrayInputStream bais = new ByteArrayInputStream(ganttDiagram);
                try {
                    image = ImageIO.read(bais);
                } catch (IOException ioe) { }

                ImageIcon icon = new ImageIcon(image); 

                JFrame frame = new JFrame("Gantt Diagram");  
                frame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);  

                JPanel panel = (JPanel)frame.getContentPane();  

                JLabel label = new JLabel();  
                label.setIcon(icon);// your image here  
                panel.add(label);  

                frame.setLocationRelativeTo(null);  
                frame.pack();  
                frame.setVisible(true);
                frame.toBack();
                try {
                    String tempPath = getClass().getProtectionDomain().getCodeSource().getLocation().toString();
                    ImageIO.write( image, "png", new File(tempPath.substring(tempPath.indexOf("/"), tempPath.lastIndexOf("/")+1)+problemName+"_gantt.png"));
                    appendToPane(Logger, "Gantt diagram is  available in the provided directory. \n", Color.blue);
                } catch(IOException ioe) {
                    appendToPane(Logger, "problem during gantt Saving. \n", Color.orange);
                }
                
            }
       } else {
       }
   }
    
    private void startActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startActionPerformed
        // TODO add your handling code here:
        // fermer les frames ouvertes
        Frame[] openFrame = Frame.getFrames();
        int fr = 1;
        while (fr++<openFrame.length-1) {
            openFrame[fr].setVisible(false);
            openFrame[fr].dispose();
        }

        try {
            Logger.setText("");
            appendToPane(Logger, "Getting local data. \n", Color.blue);
            InputStream ips = new FileInputStream(new File(path.getText()));
            if (ips != null) {
                // connect to server
                appendToPane(Logger, "Connect to the server. \n", Color.blue);
                jstl_ws_package.WebServiceJSTL_Service service = new jstl_ws_package.WebServiceJSTL_Service();
                jstl_ws_package.WebServiceJSTL port = service.getWebServiceJSTLPort();

                //get file
                byte[] dataInByte = new byte[ips.available()];
                ips.read(dataInByte);
                ips.close();

                if (isSinglEval.isSelected()) {
                    appendToPane(Logger, "Transforming local data into a Problem. \n", Color.blue);
                    Probleme un_prob = port.createProblem(dataInByte);
                    if (un_prob != null) {
                        appendToPane(Logger, "Problem succesfully created. \n", Color.blue);
                        Solution une_sol = null;
                        if (randBierwirth.isSelected()) {
                            appendToPane(Logger, "Create an evaluated solution supporting a Random Bierwirth Vector. \n", Color.blue);
                            une_sol = port.generateRandBierwirth(un_prob);
                        } else if(canBierwirth.isSelected()){ 
                            appendToPane(Logger, "Create an evaluated solution supporting a cannonical Bierwirth Vector. \n", Color.blue);
                            une_sol = port.generateCanBierwirth(un_prob);
                        } 

                        if (une_sol != null) {
                            appendToPane(Logger, "Solution succesfully created. \n", Color.blue);
                            appendToPane(Logger, "Solution cost: " + une_sol.getCout()+" \n", Color.blue);
                            displayGantt(port, un_prob, une_sol);
                        }
                    }
                } else {
                    Holder<String> stringError = new Holder<String>();
                    Holder<Integer> error = new Holder<Integer>();
                    error.value = 1;
                    
                    appendToPane(Logger, "Launching GRASP. \n", Color.blue);
                    
                    int nbIterMax = Integer.parseInt(nbRestart.getText());
                    int nbDeplMax = Integer.parseInt(nbDeplacement.getText());
                    int nbVoisinMax = Integer.parseInt(nbVoisin.getText());
                    // launching grasp
                    Probleme un_prob = port.createProblem(dataInByte);
                    String id = port.startGRASP(dataInByte, stringError, nbIterMax, nbDeplMax, nbVoisinMax);

                    if (id != null) {
                        appendToPane(Logger, "id : " + id +"\n", Color.blue);
                        appendToPane(Logger, "GRASP succesfully launched. \n", Color.blue);
                        progressbar.setValue(0);
                        // tache parallelisée pour avoir une actualisation de l'affichage
                        final TacheParallele tache = new TacheParallele(id, port, un_prob, nbIterMax);
                       
                        tache.addPropertyChangeListener(new PropertyChangeListener() {
                            @Override
                            public void propertyChange(PropertyChangeEvent evt) {
                                if(tache.error.value == -2) {
                                    if (progressbar != null) {
                                        progressbar.setValue((tache.progress.value*100)/tache.nbTirage);
                                    } 
                                } else if(tache.error.value == 0) {
                                      appendToPane(Logger, " GRASP finished \n", Color.blue);
                                      appendToPane(Logger, "Cost of the solution : "+tache.une_sol.getCout()+" \n", Color.blue);
                                      displayGantt(tache.port, tache.un_prob, tache.une_sol);
                                      appendToPane(Logger, "Execution successfully ended. \n", Color.green);
                                      progressbar.setValue(100);
                                } else if (tache.error.value == -3) {
                                      appendToPane(Logger, " GRASP finished \n", Color.orange);
                                      appendToPane(Logger, tache.stringError.value+" \n", Color.orange);
                                      appendToPane(Logger, "Cost of the solution : "+tache.une_sol.getCout()+" \n", Color.orange);
                                      displayGantt(tache.port, tache.un_prob, tache.une_sol);
                                      appendToPane(Logger, "Problem during execution. \n", Color.red);
                                      progressbar.setValue(100);
                                } else if (tache.error.value == -5) {
                                    appendToPane(Logger, " Too many requests \n", Color.orange);
                                    appendToPane(Logger, " Wait a moment and try to get your solution manually \n", Color.orange);
                                    appendToPane(Logger, "Problem during execution. \n", Color.red); 
                                }
                              }     
                          });

                            stopGrasp.addActionListener(new ActionListener() {
                            @Override
                            public void actionPerformed(ActionEvent e) {
                                tache.port.stopGRASP(tache.idG, tache.error, tache.stringError);
                                tache.une_sol = tache.port.readGRASP(tache.idG, tache.error, tache.stringError, tache.progress);
                                appendToPane(Logger, " GRASP abborted \n", Color.blue);
                                appendToPane(Logger, tache.stringError.value+" \n", Color.orange);
                                appendToPane(Logger, "Cost of the solution : "+tache.une_sol.getCout()+" \n", Color.orange);
                                displayGantt(tache.port, tache.un_prob, tache.une_sol);
                                appendToPane(Logger, "Problem during execution. \n", Color.red);
                                progressbar.setValue(100);
                                tache.cancel(true);

                            }
                        });

                        tache.execute();
                    } else {
                        appendToPane(Logger, "Error : " + stringError.value +"\n", Color.red);
                    }
                } 

            } else {
                appendToPane(Logger, "Error - Problem with file. \n", Color.orange);
                appendToPane(Logger, "Execution failed. \n", Color.red);
            }

        } catch (FileNotFoundException fnfe) {
            appendToPane(Logger, "File not Found Exception. \n", Color.red);
            appendToPane(Logger, "Execution failed. \n", Color.red);
        } catch (IOException ioe){
            appendToPane(Logger, "Exception  - cause : "+ioe.toString()+". \n", Color.red);
            appendToPane(Logger, "Execution failed. \n", Color.red);
        } catch (WebServiceException wse){
            appendToPane(Logger, "Exception  - cause : "+wse.toString()+". \n", Color.red);
            appendToPane(Logger, "Execution failed. \n", Color.red);
        } catch (Exception e ) {
            appendToPane(Logger, "Exception  - cause : "+e.toString()+". \n", Color.red);
            appendToPane(Logger, "Execution failed. \n", Color.red);
        }
        
        
        
    }//GEN-LAST:event_startActionPerformed

    private void displayGanttActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_displayGanttActionPerformed
        
    }//GEN-LAST:event_displayGanttActionPerformed

    private void randBierwirthActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_randBierwirthActionPerformed
        if (randBierwirth.isSelected()) {
            canBierwirth.setSelected(false);  
        } else {
             canBierwirth.setSelected(true); 
        }
    }//GEN-LAST:event_randBierwirthActionPerformed

    private void isGRASPActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_isGRASPActionPerformed
        if (isGRASP.isSelected()) {
            isSinglEval.setSelected(false);
            randBierwirth.setSelected(false);
            canBierwirth.setSelected(false);
            randBierwirth.setEnabled(false);
            canBierwirth.setEnabled(false);
            nbRestart.setText("10");
            nbDeplacement.setText("10");
            nbVoisin.setText("10");
            nbRestart.setEnabled(true);
            nbDeplacement.setEnabled(true);
            nbVoisin.setEnabled(true);
        } else {
            isSinglEval.setSelected(true);
            randBierwirth.setSelected(true);
            randBierwirth.setEnabled(true);
            canBierwirth.setEnabled(true);
            canBierwirth.setSelected(false);
            nbRestart.setText("00");
            nbRestart.setEnabled(false);
            nbDeplacement.setText("00");
            nbDeplacement.setEnabled(false);
            nbVoisin.setText("00");
            nbVoisin.setEnabled(false);
        }
    }//GEN-LAST:event_isGRASPActionPerformed

    private void isSinglEvalActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_isSinglEvalActionPerformed
        if (isSinglEval.isSelected()) {
            isGRASP.setSelected(false);
            randBierwirth.setSelected(true);
            canBierwirth.setSelected(false);
            randBierwirth.setEnabled(true);
            canBierwirth.setEnabled(true);
            nbRestart.setText("00");
            nbRestart.setEnabled(false);
            nbDeplacement.setText("00");
            nbDeplacement.setEnabled(false);
            nbVoisin.setText("00");
            nbVoisin.setEnabled(false);
        } else {
            isGRASP.setSelected(true);
            randBierwirth.setSelected(false);
            canBierwirth.setSelected(false);
            randBierwirth.setEnabled(false);
            canBierwirth.setEnabled(false);
            nbRestart.setText("10");
            nbRestart.setEnabled(true);
            nbDeplacement.setText("10");
            nbDeplacement.setEnabled(true);
            nbVoisin.setText("10");
            nbVoisin.setEnabled(true);
        }
    }//GEN-LAST:event_isSinglEvalActionPerformed

    private void canBierwirthActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_canBierwirthActionPerformed
        // TODO add your handling code here:
        if (canBierwirth.isSelected()) {
            randBierwirth.setSelected(false);
        } else {
            randBierwirth.setSelected(true);
        }
    }//GEN-LAST:event_canBierwirthActionPerformed

    private void nbRestartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nbRestartActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_nbRestartActionPerformed

    private void nbVoisinActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nbVoisinActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_nbVoisinActionPerformed

    private void nbDeplacementActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nbDeplacementActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_nbDeplacementActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Window.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                
                new Window().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextPane Logger;
    private javax.swing.JCheckBox canBierwirth;
    private javax.swing.JCheckBox displayGantt;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JCheckBox isGRASP;
    private javax.swing.JCheckBox isSinglEval;
    private javax.swing.JFrame jFrame1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSeparator jSeparator5;
    private javax.swing.JSeparator jSeparator7;
    private javax.swing.JTextField nbDeplacement;
    private javax.swing.JTextField nbRestart;
    private javax.swing.JTextField nbVoisin;
    private javax.swing.JTextField path;
    private javax.swing.JProgressBar progressbar;
    private javax.swing.JCheckBox randBierwirth;
    private javax.swing.JButton start;
    private javax.swing.JButton stopGrasp;
    // End of variables declaration//GEN-END:variables

    private void appendToPane(JTextPane tp, String msg, Color c) {
        StyleContext sc = StyleContext.getDefaultStyleContext();
        AttributeSet aset = sc.addAttribute(SimpleAttributeSet.EMPTY, StyleConstants.Foreground, c);

        aset = sc.addAttribute(aset, StyleConstants.FontFamily, "Lucida Console");
        aset = sc.addAttribute(aset, StyleConstants.Alignment, StyleConstants.ALIGN_JUSTIFIED);

        int len = tp.getDocument().getLength();
        tp.setCaretPosition(len);
        tp.setCharacterAttributes(aset, false);
        tp.replaceSelection(msg);
        tp.repaint();
    }

  
}

class ImageLabel extends JLabel {

  public ImageLabel(String img) {
    this(new ImageIcon(img));
  }

  public ImageLabel(ImageIcon icon) {
    setIcon(icon);
    // setMargin(new Insets(0,0,0,0));
    setIconTextGap(0);
    // setBorderPainted(false);
    setBorder(null);
    setText(null);
    setSize(icon.getImage().getWidth(null), icon.getImage().getHeight(null));
  }
  

}

// inspiré de : http://java.mesexemples.com/swing/
class TacheParallele extends SwingWorker<Integer, Integer> {
  private static final int DELAY = 1000;
  public String idG;
  public Probleme un_prob;
  jstl_ws_package.WebServiceJSTL port;
  public Solution une_sol;
  public int nbTirage;
  Holder<String> stringError;
  Holder<Integer> error;
  Holder<Integer> progress;
  
  
  public TacheParallele() {
  }
  
  public TacheParallele(String idG, jstl_ws_package.WebServiceJSTL port, Probleme un_prob, int nbTirage) {
      this.idG = idG;
      this.port = port;
      this.un_prob=un_prob;
      this.nbTirage=nbTirage;
      stringError = new Holder<String>();
      progress = new Holder<Integer>();
      error = new Holder<Integer>();
  }
 
 // A exécuter en arrière plan
  protected Integer doInBackground() throws Exception {
        int i = 0;
        error.value=-2;   
        while (error.value == -2) {
            setProgress(i++);
            Thread.sleep(DELAY*2);
            une_sol = port.readGRASP(idG, error, stringError, progress);
        }
 
    return 0;
  }
 
  protected void arret() {

      if (isCancelled())
        System.out.println("Annuler");
      else
        System.out.println("Terminer");

  }
}


class MyPainter implements Painter<JProgressBar> {

    private final Color color;

    public MyPainter(Color c1) {
        this.color = c1;
    }
    
    @Override
    public void paint(Graphics2D gd, JProgressBar t, int width, int height) {
        gd.setColor(color);
        gd.fillRect(0, 0, width, height);
    }
}